/* charsub.c 
   by Steven L. Barnicki, Feb. 1998, for the briefcase 
     - needs the external subroutine ewait & ewait1ms in wait.asm   
     - compile with createa1.bat
*/

#include <common.h>
#include <string.h>

extern void ewait(int ms);
extern void ewait1ms(void);

void lshowstring(char* sin);

void main()
{
  char* porta =(char*) 0x1000;
  char* pioc  =(char*) 0x1002;
  char* portc =(char*) 0x1003;
  char* portb =(char*) 0x1004;
  char* portcl=(char*) 0x1005;
  char* ddrc  =(char*) 0x1007;
  char* portd =(char*) 0x1008;
  char* ddrd  =(char*) 0x1009;
  char* porte =(char*) 0x100A;

  /* char str[10]; */

  lshowstring("HI THERE, THIS WORKS!");
  ewait(5000);
  lshowstring("WOW, THIS IS GREAT!");
} /* main() */

void lshowstring(char* sin)
{
  byte* s=sin;
  byte* portb =(char*) 0x1004;
  byte* portcl=(char*) 0x1005;
  byte* pioc  =(char*) 0x1002;
  byte* ddrc  =(char*) 0x1007;
  byte j;
  byte pos=4;

  /* set port c direction out */
  (*ddrc) = (byte) 0xFF;
  /* invert sense of STRB */
  j=(*pioc);
  j=j&0xfe; /* reset bit 0 to 0 */
  (*pioc)=j;

  while( *s != '\0' )
  {
    if (pos==0)
      {
      pos=4;
      s-=3;
      ewait(250);
      }
    else  /* ok to print */
      {
      (*portcl)=pos-1;
      pos--;
      (*portb)=(*s);
      s++;
      }
  }
} /* lshowstring() */


