;
;Wait routines of 1 sec and 1 ms
;
; prototypes
;   void ewait1ms(void);   waits one millisecond
;   void ewait(int msec);  waits for msec milliseconds
;
;
;Written by Steven L. Barnicki, Ph.D.
;       2/7/98, v1.0
;
	.module wait.asm
	.area _CODE
        .globl _ewait
        .globl _ewait1ms
;        .extern ZD0


_ewait::
	psha
	tpa
	psha
	pshx
        ldx *ZD0      ;wait ZD0 milliseconds
1$:     jsr _ewait1ms
	dex
	bne 1$
	pulx
	pula
	tap
	pula
	rts

_ewait1ms::
	psha    ;1 ms wait
	tpa
	psha
	pshx
	ldx #200
2$:     dex
	nop
	nop
	bne 2$
	pulx
	pula
	tap
	pula
	rts

