/* charsub2.c 
  written by Steven L. Barnicki, Feb. 1998
  for briefcase needs the external ewait and ewait1ms routines
  compile with createa1.bat
*/

#include <common.h>
#include <string.h>
#include <ports.h>

extern void ewait(int ms);
extern void ewait1ms(void);

void lshowstring(char* sin);

void main()
{
  lshowstring("HI THERE, THIS WORKS!");
  ewait(5000);
  lshowstring("WOW, THIS IS GREAT!");
} /* main() */

void lshowstring(char* sin)
{
  byte* s=sin;
  byte j;
  byte pos=4;

  /* set port c direction out */
  ddrc = (byte) 0xFF;
  /* invert sense of STRB */
  j=pioc;
  j=j&0xfe; /* reset bit 0 to 0 */
  pioc=j;

  while( *s != '\0' )
  {
    if (pos==0)
      {
      pos=4;
      s-=3;
      ewait(250);
      }
    else  /* ok to print */
      {
      portcl=pos-1;
      pos--;
      portb=(*s);
      s++;
      }
  }
} /* lshowstring() */


